package jmodeler;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Bezier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Computer Aided Graphics Design</p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class SurfaceCreateFrame extends JFrame implements ActionListener{
  Color newColor = new Color(0);
  String yourFile = "*.*",direc="";
  JButton jButton1 = new JButton();
  JButton colorButton = new JButton();
  JLabel gridSizeLabel = new JLabel();
  JTextField fileTextField = new JTextField();
  JTextField colorTextField = new JTextField();
  JTextField gridSizeTextField = new JTextField();
  JButton submitButton = new JButton();
  public SurfaceCreateFrame() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  public void actionPerformed(ActionEvent e){
    if (e.getSource() == submitButton) { //ok button
         //for now cancelling otherwise the logic of making the object
        //

        cancel();
      JDialog gdb = new JDialog(this,"New Surface Created");
      gdb.show();


//    ScheduleManagerFrame_AddBox smf = new ScheduleManagerFrame_AddBox(this);
    Dimension dlgSize = gdb.getPreferredSize();
    Dimension frmSize = getSize();

    Point loc = getLocation();
    gdb.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    //ccf.setModal(true);
    gdb.pack();
    gdb.setSize(200,100);
    gdb.show();

      }
    }

    void cancel() {
      dispose();
    }
  private void jbInit() throws Exception {
    jButton1.setBounds(new Rectangle(39, 47, 88, 25));
    jButton1.setText("File");
    jButton1.addActionListener(new SurfaceCreateFrame_jButton1_actionAdapter(this));
    this.getContentPane().setBackground(Color.white);
    this.getContentPane().setLayout(null);
    colorButton.setBounds(new Rectangle(41, 115, 88, 25));
    colorButton.setText("Color");
    colorButton.addActionListener(new SurfaceCreateFrame_colorButton_actionAdapter(this));
    gridSizeLabel.setText("Grid Size");
    gridSizeLabel.setBounds(new Rectangle(45, 180, 85, 23));
    fileTextField.setText("*.txt");
    fileTextField.setBounds(new Rectangle(192, 44, 123, 24));
    colorTextField.setBackground(Color.white);
    colorTextField.setText("Balck");
    colorTextField.setBounds(new Rectangle(194, 115, 126, 21));
    gridSizeTextField.setText("2");
    gridSizeTextField.setBounds(new Rectangle(196, 174, 125, 21));
    submitButton.setBounds(new Rectangle(137, 226, 88, 25));
    submitButton.setText("Ok");
    this.getContentPane().add(jButton1, null);
    this.getContentPane().add(colorButton, null);
    this.getContentPane().add(gridSizeLabel, null);
    this.getContentPane().add(fileTextField, null);
    this.getContentPane().add(colorTextField, null);
    this.getContentPane().add(gridSizeTextField, null);
    this.getContentPane().add(submitButton, null);
    submitButton.addActionListener(new SurfaceCreateFrame_submitButton_actionAdapter(this));
    this.setTitle("Surface Create");
  }

  void jButton1_actionPerformed(ActionEvent e) {
    FileDialog d = new FileDialog(
                SurfaceCreateFrame.this,"PLEASE ENTER THE FILE YOU WANT AS INPUT:");
              d.setFile("*.txt");
              d.setDirectory(".");
              d.show();

              if((yourFile = d.getFile()) != null) {
                //ext = yourFile.substring((yourFile.length()-2),yourFile.length());
                direc =d.getDirectory();
                fileTextField.setText(yourFile);
              }

  }

  void colorButton_actionPerformed(ActionEvent e) {
    Color newColor = JColorChooser.showDialog(SurfaceCreateFrame.this,"choose color",Color.BLACK);
            if(newColor != null){
              String stringColor = newColor.toString();
              colorTextField.setText(stringColor);
            }

  }

  void submitButton_actionPerformed(ActionEvent e) {
this.actionPerformed(e);
  }

}

class SurfaceCreateFrame_jButton1_actionAdapter implements java.awt.event.ActionListener {
  SurfaceCreateFrame adaptee;

  SurfaceCreateFrame_jButton1_actionAdapter(SurfaceCreateFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class SurfaceCreateFrame_colorButton_actionAdapter implements java.awt.event.ActionListener {
  SurfaceCreateFrame adaptee;

  SurfaceCreateFrame_colorButton_actionAdapter(SurfaceCreateFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.colorButton_actionPerformed(e);
  }
}

class SurfaceCreateFrame_submitButton_actionAdapter implements java.awt.event.ActionListener {
  SurfaceCreateFrame adaptee;

  SurfaceCreateFrame_submitButton_actionAdapter(SurfaceCreateFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.submitButton_actionPerformed(e);
  }
}
