package jmodeler;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.borland.jbcl.layout.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class SurfaceCurvatureFrame extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton ok = new JButton();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JSpinner jSpinner1 = new JSpinner();
  JPanel jPanel3 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JLabel jLabel2 = new JLabel();
  JSpinner jSpinner2 = new JSpinner();
  JButton jButton2 = new JButton();
  JTextField jTextField1 = new JTextField();
  SpinnerModel sm = new SpinnerNumberModel(0.1,0.0,1.0,0.05);
  SpinnerModel sm1 = new SpinnerNumberModel(0.1,0.0,1.0,0.05);
  String string = null;
  Surface s = null;
  Viewer viewer= null;
  JTextField jTextField2 = new JTextField();


  public SurfaceCurvatureFrame(Surface surface, Viewer view) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    s = surface;
    viewer = view;
  }
  private void jbInit() throws Exception {
    this.setLocale(java.util.Locale.getDefault());
    this.getContentPane().setLayout(borderLayout1);
    ok.setText("Close");
    ok.addActionListener(new SurfaceCurvatureFrame_ok_actionAdapter(this));
    jLabel1.setText("u Value");
    jPanel2.setDebugGraphicsOptions(0);
    jPanel2.setLayout(flowLayout1);
    jLabel2.setText("v Value");
    jButton2.setVerifyInputWhenFocusTarget(true);
    jButton2.setText("Find");
    jButton2.addActionListener(new SurfaceCurvatureFrame_jButton2_actionAdapter(this));
    jTextField1.setText("");
    jTextField1.setColumns(8);
    jTextField2.setText("");
    jTextField2.setColumns(8);
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    this.getContentPane().add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jSpinner1, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(jSpinner2, null);
    this.getContentPane().add(jPanel3,  BorderLayout.CENTER);
    jPanel3.add(jButton2, null);
    jPanel3.add(jTextField1, null);
    jPanel3.add(jTextField2, null);
    jSpinner1.setModel(sm);
    jSpinner1.setPreferredSize(new Dimension(50,20));
    jSpinner1.setVerifyInputWhenFocusTarget(true);

    jSpinner2.setModel(sm1);
    jSpinner2.setPreferredSize(new Dimension(50,20));
    jSpinner2.setVerifyInputWhenFocusTarget(true);


  }

  void ok_actionPerformed(ActionEvent e) {
    s.showp = false;
this.setVisible(false);
    viewer.postRedisplay();
  }

  void jButton2_actionPerformed(ActionEvent e) {
//Find button
    int size = s.bBox.size();
      Object[] pts = ((Vector)s.bBox.get(0)).toArray();
      int size1 = pts.length;
      Point3d[][] pt = new Point3d[size][size1];
      for(int a=0;a<size;a++){
        Object[] linePts = ((Vector) s.bBox.get(a)).toArray();
        for(int b=0;b<size1;b++){
          pt[a][b] = (Point3d)linePts[b];
        }
      }
      double u = ((Double)this.jSpinner1.getValue()).doubleValue();
      double v = ((Double)this.jSpinner2.getValue()).doubleValue();
      s.showp = true;
      s.p = null;
      s.makep(u,v);

      double[] curvature = Curvature.computeCurvature(pt,u,v,size,size1);
      System.out.println("The curvature is : "+curvature[0]+" "+curvature[1]);
      jTextField1.setText(String.valueOf(curvature[0]));
      jTextField2.setText(String.valueOf(curvature[1]));
      viewer.postRedisplay();
  }

}

class SurfaceCurvatureFrame_ok_actionAdapter implements java.awt.event.ActionListener {
  SurfaceCurvatureFrame adaptee;

  SurfaceCurvatureFrame_ok_actionAdapter(SurfaceCurvatureFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class SurfaceCurvatureFrame_jButton2_actionAdapter implements java.awt.event.ActionListener {
  SurfaceCurvatureFrame adaptee;

  SurfaceCurvatureFrame_jButton2_actionAdapter(SurfaceCurvatureFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}
