package jmodeler;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class CurveTangentPanel extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JPanel jPanel2 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JSpinner jSpinner1 = new JSpinner();
  Curve c = null;
  Viewer v = null;
  SpinnerModel sm = new SpinnerNumberModel(0.1,0.0,1.0,0.1);


  public CurveTangentPanel(Curve curve, Viewer view) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    c = curve;
    v = view;
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jButton1.setText("Ok");
    jButton1.addActionListener(new CurveTangentPanel_jButton1_actionAdapter(this));
    jButton2.setText("Close");
    jButton2.addActionListener(new CurveTangentPanel_jButton2_actionAdapter(this));
    jLabel1.setText("Value of t");
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton1, null);
    jPanel1.add(jButton2, null);
    this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jSpinner1, null);
    jSpinner1.setModel(sm);
    jSpinner1.setPreferredSize(new Dimension(50,20));
    jSpinner1.setVerifyInputWhenFocusTarget(true);

  }

  void jButton1_actionPerformed(ActionEvent e) {
    //produce the tangent but not close the window
    double t =((Double)jSpinner1.getValue()).doubleValue();
    c.sett(t);
    c.showp = true;
    //Point3d vec = c.return_tangent(t);
    //draw the tangent
    c.drawTangent = true;
    v.postRedisplay();
  }

  void jButton2_actionPerformed(ActionEvent e) {
//close the window
    c.drawTangent = false;
    c.showp = false;
    this.setVisible(false);
    v.postRedisplay();
  }
}

class CurveTangentPanel_jButton1_actionAdapter implements java.awt.event.ActionListener {
  CurveTangentPanel adaptee;

  CurveTangentPanel_jButton1_actionAdapter(CurveTangentPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class CurveTangentPanel_jButton2_actionAdapter implements java.awt.event.ActionListener {
  CurveTangentPanel adaptee;

  CurveTangentPanel_jButton2_actionAdapter(CurveTangentPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}
