package jmodeler;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * <p>Title: jModeler</p>
 * <p>Description: Create and View Besier curves and surfaces</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author (biswarup, chiragp, devesh, dharm, vikasj, jikku)@cse.iitb.ac.in
 * @version 1.0
 */

public class SurfaceTangentPanel extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JPanel jPanel2 = new JPanel();
  JSpinner jSpinner1 = new JSpinner();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JSpinner jSpinner2 = new JSpinner();
  SpinnerModel sm = new SpinnerNumberModel(0.1,0.0,1.0,0.05);
  SpinnerModel sm1 = new SpinnerNumberModel(0.1,0.0,1.0,0.05);
  Surface s = null;
  Viewer v = null;

  public SurfaceTangentPanel(Surface sur, Viewer view) {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    s = sur;
    v = view;
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jButton1.setText("Ok");
    jButton1.addActionListener(new SurfaceTangentPanel_jButton1_actionAdapter(this));
    jButton2.setText("Close");
    jButton2.addActionListener(new SurfaceTangentPanel_jButton2_actionAdapter(this));
    jLabel1.setText("u Value");
    jLabel2.setText("v Value");
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jButton1, null);
    jPanel1.add(jButton2, null);
    this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(jLabel1, null);
    jPanel2.add(jSpinner1, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(jSpinner2, null);
    jSpinner1.setModel(sm);
    jSpinner1.setPreferredSize(new Dimension(50,20));
    jSpinner1.setVerifyInputWhenFocusTarget(true);

    jSpinner2.setModel(sm1);
    jSpinner2.setPreferredSize(new Dimension(50,20));
    jSpinner2.setVerifyInputWhenFocusTarget(true);

  }

  void jButton1_actionPerformed(ActionEvent e) {
    double u =((Double)jSpinner1.getValue()).doubleValue();
    double v =((Double)jSpinner2.getValue()).doubleValue();
        s.setuv(u,v);
        s.showp = true;
        //Vector vec = s.tangentPlane(u,v);
        //draw the tangent
        s.drawTangent = true;
        this.v.postRedisplay();

  }

  void jButton2_actionPerformed(ActionEvent e) {
    s.drawTangent = false;
        s.showp = false;
        this.setVisible(false);
        v.postRedisplay();

  }
}

class SurfaceTangentPanel_jButton1_actionAdapter implements java.awt.event.ActionListener {
  SurfaceTangentPanel adaptee;

  SurfaceTangentPanel_jButton1_actionAdapter(SurfaceTangentPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class SurfaceTangentPanel_jButton2_actionAdapter implements java.awt.event.ActionListener {
  SurfaceTangentPanel adaptee;

  SurfaceTangentPanel_jButton2_actionAdapter(SurfaceTangentPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}
